package com.uca.dao;

import com.uca.entity.*;

import java.sql.*;
import java.util.ArrayList;

public class GommetteAttribDAO extends _Generic<GommetteAttribEntity> {

    public GommetteAttribEntity extract(ResultSet resultSet)
    {
        try {
            if (resultSet.next()) 
            {
                GommetteAttribEntity entity = new GommetteAttribEntity();
                entity.setId(resultSet.getInt("id"));
                // entity.setCouleur TODO
                entity.setIdEleve(resultSet.getInt("idEleve"));
                entity.setIdProf(resultSet.getInt("idProf"));
                entity.setIdGommette(resultSet.getInt("idGommette"));
                // entity.setDateAttrib TODO
                entity.setRaisonAttribution(resultSet.getString("raison"));
                return entity;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    public ArrayList<GommetteAttribEntity> getAll() { return getAllGommetteAttribs(); }
    public ArrayList<GommetteAttribEntity> getAllGommetteAttribs() {
        ArrayList<GommetteAttribEntity> entities = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = this.connect
                    .prepareStatement("SELECT * FROM gommetteAttribs ORDER BY id ASC;");
            ResultSet resultSet = preparedStatement.executeQuery();
            while(true)
            {
                GommetteAttribEntity entity = extract(resultSet);
                if(entity == null) { return entities;}
                entities.add(entity);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return entities;
    }

    public GommetteAttribEntity getById(int id)
    {
        GommetteAttribEntity entity = null;
        try {
            PreparedStatement stmt = this.connect.prepareStatement("SELECT * FROM gommetteAttribs where id = ?;");
            stmt.setInt(1, id);
            return extract(stmt.executeQuery());
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return entity;
    }

    @Override
    public GommetteAttribEntity create(GommetteAttribEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("insert into gommetteAttribs (id, idEleve, idProf, raison) values (?, ?, ?, ?);");
            int idx = 1;
            stmt.setInt   (idx++, obj.getId());
            stmt.setInt   (idx++, obj.getIdEleve());
            stmt.setInt   (idx++, obj.getIdProf());
            stmt.setString(idx++, obj.getRaisonAttribution());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return obj;
    }

    @Override
    public void delete(GommetteAttribEntity obj) {
        delete(obj.getId());
    }

    public void delete(int id) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("DELETE FROM gommetteAttribs WHERE id = ?;");
            stmt.setInt(1, id);
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
