package com.uca.dao;

import com.uca.entity.ProfEntity;

import java.sql.*;
import java.util.ArrayList;

public class ProfDAO extends _Generic<ProfEntity> {

    public ProfEntity extract(ResultSet resultSet)
    {
        try {
            if (resultSet.next()) 
            {
                ProfEntity entity = new ProfEntity();
                entity.setId(resultSet.getInt("id"));
                entity.setFirstName(resultSet.getString("firstName"));
                entity.setLastName(resultSet.getString("lastName"));
                entity.setUserName(resultSet.getString("userName"));
                return entity;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    public ArrayList<ProfEntity> getAll() { return getAllProfs(); }
    public ArrayList<ProfEntity> getAllProfs() {
        ArrayList<ProfEntity> entities = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = this.connect.prepareStatement("SELECT * FROM profs ORDER BY id ASC;");
            ResultSet resultSet = preparedStatement.executeQuery();
            
            while(true)
            {
                ProfEntity entity = extract(resultSet);
                if(entity == null) { return entities;}
                entities.add(entity);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return entities;
    }

    public ProfEntity getById(int id)
    {
        ProfEntity entity = null;
        try {
            PreparedStatement stmt = this.connect.prepareStatement("SELECT * FROM profs where id = ?;");
            stmt.setInt(1, id);
            return extract(stmt.executeQuery());
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return entity;
    }

    @Override
    public ProfEntity create(ProfEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("insert into profs (id, firstName, lastName, userName) values (?, ?, ?, ?);");
            int idx = 1;
            stmt.setInt   (idx++, obj.getId());
            stmt.setString(idx++, obj.getFirstName());
            stmt.setString(idx++, obj.getLastName());
            stmt.setString(idx++, obj.getUserName());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return obj;
    }

    @Override
    public void delete(ProfEntity obj) {
        delete(obj.getId());
    }

    public void delete(int id) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("DELETE FROM profs WHERE id = ?;");
            stmt.setInt   (1, id);
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
